/*
 * Created on 2005-03-05
 *
 */
package vr.system;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import javax.swing.JFileChooser;

import rseslib.structure.attribute.Header;
import rseslib.structure.data.DoubleDataTable;
import rseslib.system.Report;
import rseslib.system.output.FileOutput;
import vr.system.classifiersManagement.ClassifiersManager;
import vr.system.options.StandaloneSavableConfiguration;
import vr.visual.LogPanel;
import vr.visual.VROptions;

/**
 * Przechowuje podstawowe dane wykorzystywane w programie.
 *
 * @author Michal Manski, Marcin Staszczyk
 *
 */
public class DataManager {
	/** aktualny naglowek z danymi */
	static public Header dataHeader = null;
	/** aktualna tabela z danymi testowymi */
	static public DoubleDataTable testData = null;
	/** aktualna tabela z danymi treningowymi */
	static public DoubleDataTable trainData = null;
	/** zarzadca klasyfikatorow */
	static public ClassifiersManager classifiersManager = new ClassifiersManager();
	/** wybrane klasyfikatory */
	static public ArrayList chosenClassifiers = new ArrayList();
	/** selektor plikow */
	static public JFileChooser fileChooser = new JFileChooser(".");
	/** Log uzywany przez system VR */
	static public LogPanel panel;
	/** inicjalizacja powyzszego Log-u i innych zmiennych */
	static {
		panel = new LogPanel();
		panel.setOpaque(true);

		StandaloneSavableConfiguration conf = new StandaloneSavableConfiguration(VROptions.class);


		Report.setDebugDisplay(conf.getBoolProperty(VROptions.displayDebug));
		Report.setInfoDisplay(conf.getBoolProperty(VROptions.displayDisplay));
		panel.setOpenErrorWindow(conf.getBoolProperty(VROptions.windowError));
		panel.setOpenDebugWindow(conf.getBoolProperty(VROptions.windowDebug));
		panel.setOpenDisplayWindow(conf.getBoolProperty(VROptions.windowDisplay));

		try {
            FileOutput fo = new FileOutput(new File(conf.getProperty(VROptions.debugFileProp)));
            Report.addErrorOutput(fo);
            Report.addDebugOutput(fo);
		} catch (IOException e) {}
		try {
			Report.addInfoOutput(new FileOutput(new File(conf.getProperty(VROptions.displayFileProp))));
		} catch (IOException e1) {}

        Report.addDebugOutput(new VisualDebugOutput(panel));
        Report.addInfoOutput(new VisualInfoOutput(panel));
        Report.addErrorOutput(new VisualErrorOutput(panel));

        fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
	}

}
