/*
 * Created on 2005-03-08
 *
 */
package vr.system.classifiersManagement;

/**
 * Stworzona na potrzeby wygodnego zwracania jako result klasa
 * przechowyjaca inforamacje o nazwie i flagach klasyfikatora.
 * 
 * @author Marcin Staszczyk i Michal Manski
 */
public class ClassifierInfo {
	/** nazwa klasyfikatora */
	public String name;
	/** flagi klasyfikatora */
	public int flags;
	/** licznik wybranych klasyfikatorow */
	private int count = 0;
	
	/**
	 * Konstruktor klasy ustawiajacy przechowywane warotsci
	 * 
	 * @param clName	Nazwa klasyfikatora
	 * @param clFlags	Flagi klasyfikatora
	 */
	public ClassifierInfo(String clName, int clFlags)
	{
		name = clName;
		flags = clFlags;
	}
	
	
	/**
	 * Tekstowa reprezentacja tego klasyfikatora.
	 * 
	 * @return nazwa klasyfikatora
	 */
	public String toString() {
		return name;
	}
	/**
	 * Metoda zwraca jednoznacznie identfikowalna nazwe klasyfikatora.
	 * @return Nazwa klasyfikatora
	 */
	public String getNextName() {
		count++;
		if (count == 1)
			return name;
		else
			return name+'-'+count;
	}
}
