/*
 * Created on 2005-06-08
 *
 */
package vr.system.classifiersManagement;

import vr.system.options.StandaloneSavableConfiguration;

/**
 * Klasa odpowiedzialna za reprezentowanie "egzemplarza" danego klasyfikatora
 * wraz z jego opcjami i jednoznaczna nazwa. 
 *
 * @author Michal Manski
 *
 */
public class ClassifierInstanceInfo {
	/** nazwa klasyfikatora */
	public String name;
	/** flagi klasyfikatora */
	public int flags;
	/** opcje klasyfikatora */
	public StandaloneSavableConfiguration config;
	/** klasa klasyfikatora */
	public Class clas;
	
	/**
	 * Konstruktor klasy ustawiajacy przechowywane wartosci.
	 * 
	 * @param clName	Nazwa klasyfikatora
	 * @param clFlags	Flagi klasyfikatora
	 * @param ssc		Obiekt przechowujacy opcje
	 * @param c			Klasa klasyfikatora
	 */
	public ClassifierInstanceInfo(String clName, int clFlags,
			StandaloneSavableConfiguration ssc, Class c)
	{
		name = clName;
		flags = clFlags;
		config = ssc;
		clas = c;
	}
	
	/**
	 * Tekstowa reprezentacja tego klasyfikatora.
	 * 
	 * @return nazwa klasyfikatora
	 */
	public String toString() {
		return name;
	}
}
