/*
 * Created on 2005-02-27
 *
 */
package vr.system.progress;

import java.awt.Insets;
import java.awt.LayoutManager;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.Spring;
import javax.swing.SpringLayout;

import rseslib.system.progress.AbstractProgress;
/**
 * Wyswietla informacje o postepie w nowym oknie.
 * 
 * @author Michal Manski
 *
 */
public class VisualStdOutProgress extends AbstractProgress 
{
    /** Aktualny krok tego "progressu". */
    int m_nCurrentPoint;
    /** Czas kiedy zaczelo si liczenie postepu. */
    long m_nStartTime;
    /** Pasek postpu. */
    JProgressBar progressBar;
    /** "TextArea" do wyswietlania informacji. */
    JTextArea textArea;
    /**
     * Ustawia laczna liczbe krokow do wykonania.
     *
     * @param name      Nazwa tego "progressu".
     * @param noOfSteps Liczba krokow.
     */
    public void set(String name, int noOfSteps)
    {
        super.set(name, noOfSteps);
        m_nCurrentPoint = 0;

        JFrame frame = new JFrame("VRWindow postepu");

        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

        LayoutManager m = new SpringLayout();
        frame.getContentPane().setLayout(m);
        
        progressBar = new JProgressBar(0, noOfSteps);
        progressBar.setValue(0);
        progressBar.setStringPainted(true);
        JLabel label = new JLabel(m_Name+":");
        textArea = new JTextArea(5,20);
        textArea.setMargin(new Insets(5,5,5,5));
        textArea.setEditable(false);
        textArea.setCursor(null);

        frame.getContentPane().add(label, new SpringLayout.Constraints(
        	    Spring.constant(10),Spring.constant(10),
			    Spring.constant(180),Spring.constant(25)));
        frame.getContentPane().add(progressBar, new SpringLayout.Constraints(
        	    Spring.constant(210),Spring.constant(10),
			    Spring.constant(200),Spring.constant(25)));
        frame.getContentPane().add(new JScrollPane(textArea), new SpringLayout.Constraints(
        	    Spring.constant(10),Spring.constant(50),
			    Spring.constant(400),Spring.constant(60)));
        frame.pack();
        frame.setSize(430,160);
        frame.setVisible(true);
        frame.setResizable(false);
        m_nStartTime = System.currentTimeMillis();
    }

    /**
     * Wykonuje pojedynczy krok.
     *
     * @throws InterruptedException 
     */
    public void step() throws InterruptedException
    {
        m_nCurrentPoint++;
        progressBar.setValue(m_nCurrentPoint);

        if (m_nCurrentPoint==m_nEndPoint)
        {
            long durationTime = System.currentTimeMillis() - m_nStartTime;
            textArea.append("Time: " + (durationTime/1000) + "s " +  (durationTime%1000) + "ms");
        }
    }

}