/*
 * Created on Apr 10, 2005
 *
 */
package vr.visual;

import java.util.Map;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import rseslib.system.Report;
import vr.data.LastClassificationInfo;
import vr.processing.classification.GeneralMultiClassifier;
import vr.system.DataManager;
import vr.system.classifiersManagement.ClassifierInstanceInfo;
import vr.system.options.StandaloneSavableConfiguration;
import vr.visual.results.ClassificationResultsPanel;

/**
 *
 * Watek odpowiedzialny za przeprowadzenie klasyfikacji.
 *
 * @author Tomek Romanczuk, Michal Manski
 */
public class ClassifyThread extends Thread {
	JFrame frame;
	private StandaloneSavableConfiguration conf;

	/**
	 * Przeprowadzanie klasyfikacji.
	 */
	public void run()
	{
		Object[] opt = {"Tak", "Nie"};

		int n = JOptionPane.showOptionDialog(
				VRWindow.mainWindow,
				"Czy chcesz przeprowadzic klasyfikacje z wybranymi klasyfikatorami?",
				"Klasyfikacja",
				JOptionPane.YES_NO_OPTION,
				JOptionPane.QUESTION_MESSAGE,
				null,
				opt,
				opt[1]);

		if ( n != JOptionPane.YES_OPTION)
			return;

		GeneralMultiClassifier genClassifier = new GeneralMultiClassifier();

		/* dodanie wszystkich wybranych klasyfikatorow */
		for (int i=0; i<DataManager.chosenClassifiers.size(); i++)
		{
			ClassifierInstanceInfo inf = (ClassifierInstanceInfo) DataManager.chosenClassifiers.get(i);
			genClassifier.addNewClassifier(inf.clas,inf.flags,inf.name,inf.config);

		}

		/* przeprowadzenie klasyfikacji */
		try {
			genClassifier.train(DataManager.trainData);
			Map results = genClassifier.classify(DataManager.testData);
			LastClassificationInfo.addData(DataManager.dataHeader, DataManager.testData, DataManager.trainData);
			LastClassificationInfo.addResults(results);
			VRWindow.setNewContent(new ClassificationResultsPanel(LastClassificationInfo.getResults(), LastClassificationInfo.getHeader().nominalDecisionAttribute())); 
		} catch (InterruptedException e) {
			Report.display("Klasyfikacja przerwana!\n");
		}

	}
}
