/*
 * Created on 2005-03-20
 *
 */
package vr.visual.data;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;

import rseslib.structure.attribute.Header;
import rseslib.structure.data.DoubleDataTable;

/**
 * Panel pozwalajacy przegladac i edytowac podany zbior danych testowych 
 * lub treningowych (wyswietlany w panelu dataPanel).
 * 
 * @author Michal Manski
 *
 */
public class DataEditorPanel extends EditorPanel {
	
	/**
	 * Konstruktor.
	 * 
	 * @param data	zbior danych (testowych lub treningowych).
	 * @param hdr	naglowek danych pasujcy do powyzszego zbioru danych.
	 * @param test	zmienna logiczna rowna true wtw data jest.
	 * zbiorem danych testowych.
	 */
	public DataEditorPanel(DoubleDataTable data, Header hdr, boolean test) {
		super("Skasuj zaznaczone wiersze", "Dodaj nowy wiersz", "Zacznij edycje tabeli");
		dataPanel = new DataPresentationPanel(data, hdr, test);
		
		JPanel namePanel = new JPanel();
		namePanel.add(new JLabel(test?"Dane testowe":"Dane treningowe"));
		add(namePanel, BorderLayout.NORTH);
        add(dataPanel, BorderLayout.CENTER);
        add(panel, BorderLayout.SOUTH);
        setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));
	}
	
}
