/*
 * Created on 2005-04-06
 *
 */
package vr.visual.data;

import javax.swing.JPanel;

/**
 *
 * Abstrakcyjna klasa reprezentujaca panel pozwalajacy na 
 * wyswietlanie pewnego zbioru danych.
 *
 * @author Michal Manski
 */
public abstract class PresentationPanel extends JPanel {
	
	/**
	 * Ustawia czy prezentowane dane moga byc edytowane.
	 * 
	 * @param edit rowne true wtw gdy ustawiamy mozliwosc edytowania
	 */
	public abstract void setEditable(boolean edit);
	
	/**
	 * Sprawdza czy zbior danych jest w trakcie edycji.
	 * 
	 * @return true wtw dane sa wlasnie edytowane.
	 */
	public abstract boolean isEditing();
	
	/**
	 * Powoduje usuniecie zaznaczonych elementow ze zbioru danych.
	 *
	 */
	public abstract void removeSelectedRows();
	
	/**
	 * Powoduje dodanie nowego elementu do zbioru danych.
	 *
	 */
	public abstract void addNewRow();
	
	/** 
	 * Powoduje zapisanie zbioru danych w "globalnej" pamieci, 
	 * przedtem pytajac uzytkownika o potwierdzenie.
	 *  
	 * @return true wtw dane zostaly zapisane.
	 */
	public abstract boolean saveData();
}
