/*
 * Created on Apr 9, 2005
 *
 */
package vr.visual.dataIO;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import rseslib.structure.attribute.ArrayHeader;
import rseslib.structure.attribute.Header;
import rseslib.structure.data.ArrayListDoubleDataTable;
import rseslib.structure.data.DoubleDataTable;
import rseslib.system.Report;
import rseslib.system.progress.EmptyProgress;
import vr.system.DataManager;
import vr.visual.VRWindow;

/**
 *
 * Klasa odpowiedzialna za wczytanie pliku zawierajacego naglowek danych
 * (z mozliwoscia rownoczesnego wczytania danych treningowych i testowych).
 *
 * @author Michal Manski, Tomasz Romanczuk
 *
 */
public class HeaderReader implements ActionListener{
	static JFrame frame;
	static JFrame frame1;
	JFileChooser fc;
	JPanel panel;
	static File file;
	boolean decision = false;
	JTextField trainFile = new JTextField(15);
	JTextField testFile = new JTextField(15);

	/**
	 * Konstruktor
	 *
	 */
	public HeaderReader()
	{

		frame = new JFrame("Wczytanie pliku naglowkowego");
		panel = new JPanel(new BorderLayout());

		fc = DataManager.fileChooser;
		fc.setDialogType(JFileChooser.OPEN_DIALOG);
		fc.rescanCurrentDirectory();

		JPanel mPanel = new JPanel();
		mPanel.setLayout(new BoxLayout(mPanel, BoxLayout.PAGE_AXIS));
		mPanel.add(new JLabel("Dane treningowe"));
		JPanel trainPanel = new JPanel(new BorderLayout());
		trainPanel.add(trainFile, BorderLayout.NORTH);
		mPanel.add(trainPanel);
		mPanel.add(new JLabel("Dane testowe"));
		JPanel testPanel = new JPanel(new BorderLayout());
		testPanel.add(testFile, BorderLayout.NORTH);
		mPanel.add(testPanel);
		mPanel.setBorder(BorderFactory.createEmptyBorder(15, 15, 15, 15));
		fc.setAccessory(mPanel);

		fc.addActionListener(this);
		panel.add(fc);

		frame.setContentPane(panel);
		frame.pack();
		frame.setVisible(true);
	}

	/**
	 * Obsluga akcji podjetych przez uzytkownika.
	 */
	public void actionPerformed(ActionEvent e) {

		if (e.getActionCommand() == "ApproveSelection") {
			/* Wczytujemy */
			file = null;
			file = fc.getSelectedFile();

			if ( file.isFile())
			{
				/* Wybrano poprawny plik */
				if ( DataManager.dataHeader == null )
					decision = true;
				else
				{
					Object[] opt = {"Tak", "Nie"};

					int n = JOptionPane.showOptionDialog(
							frame,
							"Naglowek danych jest juz wczytany.\n" +
							"Czy chcesz go nadpisac?",
							"HeaderReader",
							JOptionPane.YES_NO_OPTION,
							JOptionPane.QUESTION_MESSAGE,
							null,
							opt,
							opt[1]);

					if ( n == JOptionPane.YES_OPTION)
						decision = true;
					else
						decision = false;

				}

				if (decision)
				{
					Header header = null;
					try {
						header = new ArrayHeader(file);
						DataManager.dataHeader = header;
						DataManager.trainData = null;
						DataManager.testData = null;
						DataManager.panel.setHeaderFile(file.getAbsolutePath());
						DataManager.panel.setHeaderModified(false);
						DataManager.panel.setTrainingFile(null);
						DataManager.panel.setTrainingModified(false);
						DataManager.panel.setTestFile(null);
						DataManager.panel.setTestModified(false);
						DataManager.chosenClassifiers = new ArrayList();
						VRWindow.setNewContent(new JPanel());
					} catch (Exception e1) {
						Report.exception(e1);
						Report.displaynl("Blad przy czytaniu naglowka, zobacz raport bledu.");
					}
					if (header != null) {
						/* Wczytuje dane testowe */
						String parent = file.getParent();
						File tFile = new File(parent+File.separatorChar+testFile.getText());
						if (tFile.isFile())
							try {
								DoubleDataTable test = new ArrayListDoubleDataTable(tFile, DataManager.dataHeader, new EmptyProgress());
								DataManager.testData = test;
								DataManager.panel.setTestFile(tFile.getAbsolutePath());
							} catch (Exception e1) {
                                Report.exception(e1);
        						Report.displaynl("Blad przy czytaniu danych testowych, zobacz raport bledu.");
							}

						/* Wczytuje dane treningowe */
						tFile = new File(parent+File.separatorChar+trainFile.getText());
						if (tFile.isFile())
							try {
								DoubleDataTable train = new ArrayListDoubleDataTable(tFile, DataManager.dataHeader, new EmptyProgress());
								DataManager.trainData = train;
								DataManager.panel.setTrainingFile(tFile.getAbsolutePath());
							} catch (Exception e1) {
                                Report.exception(e1);
        						Report.displaynl("Blad przy czytaniu danych treningowych, zobacz raport bledu.");
							}
					}
					frame.dispose();
				}
			}
			else
			{
				/* wpisano nazwe nieistniejacego pliku */
				fc.removeActionListener(this);
				throw new RuntimeException("File " + file + " doesn't exists");
			}
		}
		else {
			/* Wczytanie anulowane */
			frame.dispose();
		}
		fc.removeActionListener(this);
	}
}

