/*
 * Created on Apr 10, 2005
 */
package vr.visual.dataIO;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import rseslib.structure.attribute.Header;
import rseslib.structure.data.ArrayListDoubleDataTable;
import rseslib.structure.data.DoubleDataTable;
import rseslib.system.Report;
import rseslib.system.progress.EmptyProgress;
import vr.system.DataManager;
import vr.visual.VRWindow;
/**
 *
 * Klasa odpowiedzialna za wczytywanie danych testowych z pliku.
 *
 * @author Michal Manski, Tomek Romanczuk
 */
public class TestDataReader implements ActionListener{
	static JFrame frame;
	static JFrame frame1;
	JFileChooser fc;
	JPanel panel;
	static File file;
	static Header header;
	boolean decision = false;

	/**
	 * Konstruktor
	 *
	 */
	public TestDataReader()
	{

		frame = new JFrame("Wczytanie danych testowych");
		panel = new JPanel(new BorderLayout());

		fc = DataManager.fileChooser;
		fc.setAccessory(null);
		fc.setDialogType(JFileChooser.OPEN_DIALOG);
		fc.rescanCurrentDirectory();

		fc.addActionListener(this);
		panel.add(fc);

		frame.setContentPane(panel);
		frame.pack();
		frame.setVisible(true);
	}

	/**
	 * Obsluga akcji podjetych przez uzytkownika.
	 */
	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand() == "ApproveSelection") {
			/* Wczytujemy */
			file = null;
			file = fc.getSelectedFile();

			if ( file.isFile())
			{
				/* Wybrano poprawny plik */
				if ( DataManager.testData == null )
					decision = true;
				else
				{
					Object[] opt = {"Tak", "Nie"};

					int n = JOptionPane.showOptionDialog(
							frame,
							"Dane testowe sa juz wczytane.\n" +
							"Czy chcesz je nadpisac?",
							"HeaderReader",
							JOptionPane.YES_NO_OPTION,
							JOptionPane.QUESTION_MESSAGE,
							null,
							opt,
							opt[1]);

					if ( n == JOptionPane.YES_OPTION)
						decision = true;
					else
						decision = false;

				}

				if (decision)
				{

					try {
						DoubleDataTable test = new ArrayListDoubleDataTable(file, DataManager.dataHeader, new EmptyProgress());
						DataManager.testData = test;
						DataManager.panel.setTestFile(file.getAbsolutePath());
						DataManager.panel.setTestModified(false);
						VRWindow.setNewContent(new JPanel());
					} catch (Exception e1) {
                        Report.exception(e1);
						Report.displaynl("Blad przy czytaniu danych testowych, zobacz raport bledu.");
					}
					frame.dispose();
				}
			}
			else
			{
				/* wpisano nazwe nieistniejacego pliku */
				fc.removeActionListener(this);
				throw new RuntimeException("File " + file + " doesn't exists");
			}
		}
		else {
			/* Wczytanie anulowane */
			frame.dispose();
		}
		fc.removeActionListener(this);
	}
}



