/*
 * Created on Apr 9, 2005
 */
package vr.visual.dataIO;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import rseslib.system.Report;
import rseslib.system.progress.EmptyProgress;
import vr.system.DataManager;
/**
 *
 * Klasa odpowiedzialna za zapisanie danych testowych do pliku.
 *
 * @author Tomek Romanczuk, Michal Manski
 */
public class TestDataWriter implements ActionListener{

	JFrame frame;
	JPanel panel;
	JFileChooser fc;
	File file;

	/**
	 * Konstruktor
	 *
	 */
	public TestDataWriter()
	{
		frame = new JFrame("Zapisanie danych testowych");
		panel = new JPanel(new BorderLayout());

		fc = DataManager.fileChooser;
		fc.setAccessory(null);
		fc.setDialogType(JFileChooser.SAVE_DIALOG);
		fc.rescanCurrentDirectory();

		fc.addActionListener(this);
		panel.add(fc);

		frame.setContentPane(panel);
		frame.pack();
		frame.setVisible(true);
	}

	/**
	 * Obsluga akcji podjetych przez uzytkownika.
	 */
	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand() == "ApproveSelection") {
			/* Zapisujemy */
			boolean decision;

			file = null;
			file = fc.getSelectedFile();

			if ( ! file.isFile() )
			{
				decision = true;
			}
			else
			{
				Object[] opt = {"Tak", "Nie"};

				int n = JOptionPane.showOptionDialog(
						frame,
						"Plik "+file+" juz istnieje.\n" +
						"Nadpisac go??",
						"HeaderWriter",
						JOptionPane.YES_NO_OPTION,
						JOptionPane.QUESTION_MESSAGE,
						null,
						opt,
						opt[1]);

				if ( n == JOptionPane.YES_OPTION)
					decision = true;
				else
					decision = false;

			}

			if (decision)
			{
				FileWriter fw = null;
				try {
					fw = new FileWriter(file);
				} catch (Exception e1) {
                    Report.exception(e1);
					Report.displaynl("Blad przy zapisie danych testowych, zobacz raport bledu.");
				}

				BufferedWriter bw = new BufferedWriter(fw);

				try {
					DataManager.testData.store(file, new EmptyProgress());
				} catch (Exception e2) {
                    Report.exception(e2);
					Report.displaynl("Blad przy zapisie danych testowych, zobacz raport bledu.");
				}
				frame.dispose();
			}
		}
		else {
			/* HeaderWriter anulowane */
			frame.dispose();
		}
		fc.removeActionListener(this);
	}

}
