/*
 * Created on 2005-04-07
 */
package vr.visual.graph;


/**
 * Informacja o atrybucie, wykorzystywana przy listach wyboru atrybutow
 *  
 * @author Damian Manski
 */
public class AttrInfo {
    
    /** indeks atrybutu w naglowku */
    int id;
    /** nazwa atrybutu */
    String name;
    
    /**
     * Konstruktor tworzacy informacje o atrybucie na podstawie nazwy i 
     * indeksu atrybutu w naglowku
     * 
     * @param no indeks atrybutu w naglowku
     * @param label nazwa atrybutu
     */
    public AttrInfo(int no, String label)
    {
        id = no;
        name = label;
    }
    
    /**
     * Zwraca indeks atrybutu w naglowku
     * 
     * @return indeks atrybutu w naglowku
     */
    public int getId()
    {
        return id;
    }
    
    /**
     * Zwraca nazw atrybutu
     * 
     * @return nazwa atrybutu
     */
    public String getName()
    {
        return name;
    }
    
    /**
     * Konstruuje tekstowa reprezentacje informacji o atrybucie
     * 
     * @return tekstowa reprezentacja naglowka
     */
    public String toString()
    {
        return name;
    }
    
    /**
     * Sprawdza czy podany obiekt reprezentuje ten sam naglowek
     * 
     * @return wynik porownania
     */
    public boolean equals(Object obj)
    {
        if (obj instanceof AttrInfo) {
            AttrInfo attr = (AttrInfo) obj;
            if ((id == attr.id) && (name == attr.name))
                return true;
            else 
                return false;
        }
        else return false;
    }
}
