/*
 * Created on 2005-02-28
 */
package vr.visual.graph;

import java.awt.BorderLayout;

import javax.swing.JPanel;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.xy.XYDataset;

/**
 * DrawChartNumNumSymb tworzy i rysuje diagram typu
 * numeryczne * numeryczne * symboliczne
 *  
 * @author Damian Manski
 */
public class DrawChartNumNumSymb extends JPanel {
    
    /** wyswietlany wykres */
    private JFreeChart chart;
    
    /** panel zawierajacy wykres */
    private ChartPanel panel;
    
    /**
     * Konstruktor tworzy diagram num*num*symb, na podstawie
     * zbioru danych XYDataset o zadanym tytule i nazwach osi
     * 
     * @param dataset dane na podstawie ktorych tworzony jest wykres
     * @param title tytul wykresu
     * @param xAxisLabel nazwa osi X
     * @param yAxisLabel nazwa osi Y
     */
    public DrawChartNumNumSymb(XYDataset dataset, String title, 
            String xAxisLabel, String yAxisLabel)
    {
        super(new BorderLayout());
        chart = ChartFactory.createScatterPlot(title, xAxisLabel, yAxisLabel, 
            	dataset, PlotOrientation.VERTICAL, true, true, false);
        panel = new ChartPanel(chart);
        this.add(panel, BorderLayout.CENTER);
    }
    
    /**
     * Wyswietla diagram trzymany pod zmienna chart
     */
    public void draw()
    {
        this.updateUI();
        
    }
    
    /**
     * Zwraca panel zawierajacy aktualnie wyswietlany wykres
     * 
     * @return aktualnie widoczny panel z wykresem
     */
    public ChartPanel getCurrentChartPanel()
    {
        return panel;
    }
    
}
